<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode Proyek</label>

            <b-form-input id="input-large" size="lg" disabled></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Owner Proyek</label>

            <b-form-input id="input-large" size="lg" disabled></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nama Proyek</label>

            <b-form-input id="input-large" size="lg" disabled></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nomor Kontrak</label>

            <b-form-input id="input-large" size="lg" disabled></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Status</label>

            <b-form-input
              id="input-large"
              size="lg"
              value="Open"
              disabled
            ></b-form-input>
          </div>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <b-tabs content-class="mt-3" v-model="tabsEdit">
          <!-- document tab -->
          <b-tab title="Document" active>
            <div class="d-flex justify-content-end mb-3">
              <button class="btn btn-success mr-2">
                Simpan
              </button>
              <button
                class="btn btn-primary mr-2"
                @click.prevent="loadEditChecklist('DOC')"
              >
                Load Design
              </button>
              <button
                class="btn btn-secondary"
                style="border-top-right-radius: 0; border-bottom-right-radius: 0;"
              >
                <i class="flaticon2-search-1"></i>
              </button>
              <input
                type="text"
                style="border-top-left-radius: 0; border-bottom-left-radius: 0; border: 1px solid #e6e6e6;"
              />
            </div>

            <div class="table-responsive">
              <table
                class="table table-head-custom table-vertical-center table-head-bg table-borderless"
              >
                <thead>
                  <tr class="text-left">
                    <th style="min-width: 100px">No</th>
                    <th style="min-width: 250px" class="pl-7">
                      <span class="text-dark-75">Numbering</span>
                    </th>
                    <th style="min-width: 100px">Title</th>
                    <th style="min-width: 100px">Stasiun</th>
                    <th style="min-width: 100px">Tipe</th>
                    <th style="min-width: 101px">Scope</th>
                    <th style="min-width: 101px">Logistic</th>
                    <th style="min-width: 101px">SHD External</th>
                    <th style="min-width: 101px">Change Management</th>
                  </tr>
                </thead>

                <tbody>
                  <template
                    v-for="(item, i) in this.$store.getters.getterEditChecklist"
                  >
                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': emptyTableEdit
                      }"
                    >
                      <td class="text-center" colspan="9">Data kosong</td>
                    </tr>

                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': tableLoaderEdit
                      }"
                    >
                      <td colspan="9" class="text-center">
                        <div class="text-center">
                          <b-spinner
                            variant="primary"
                            label="Spinning"
                          ></b-spinner>
                        </div>
                      </td>
                    </tr>

                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': mainTableEdit
                      }"
                    >
                      <td class="pl-0 ">
                        <span
                          class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                        >
                          {{ item.no }}
                        </span>
                      </td>

                      <td>
                        <span
                          class="text-dark-75 font-weight-bolder d-block font-size-lg"
                        >
                          {{ item.numbering }}
                        </span>
                      </td>

                      <td>
                        <span
                          class="text-dark-75 font-weight-bolder d-block font-size-lg"
                        >
                          {{ item.title }}
                        </span>
                      </td>

                      <td>
                        <span class="text-muted font-weight-bold d-block">
                          {{ item.station }}
                        </span>
                      </td>

                      <td>
                        <span class="text-muted font-weight-bold d-block">
                          {{ item.type }}
                        </span>
                      </td>

                      <td>
                        <span class="text-muted font-weight-bold d-block">
                          {{ item.scope }}
                        </span>
                      </td>

                      <td>
                        <input type="checkbox" />
                      </td>
                      <td>
                        <input type="checkbox" />
                      </td>
                      <td>
                        <input type="checkbox" />
                      </td>
                    </tr>
                  </template>
                </tbody>
              </table>
            </div>
          </b-tab>
          <!-- end document tab -->

          <!-- Drawing tab -->
          <b-tab title="Drawing">
            <div class="d-flex justify-content-end mb-3">
              <button class="btn btn-success mr-2">
                Simpan
              </button>
              <button
                class="btn btn-primary mr-2"
                @click.prevent="loadEditChecklist('DOC')"
              >
                Load Design
              </button>
              <button
                class="btn btn-secondary"
                style="border-top-right-radius: 0; border-bottom-right-radius: 0;"
              >
                <i class="flaticon2-search-1"></i>
              </button>
              <input
                type="text"
                style="border-top-left-radius: 0; border-bottom-left-radius: 0; border: 1px solid #e6e6e6;"
              />
            </div>

            <div class="table-responsive">
              <table
                class="table table-head-custom table-vertical-center table-head-bg table-borderless"
              >
                <thead>
                  <tr class="text-left">
                    <th style="min-width: 100px">No</th>
                    <th style="min-width: 250px" class="pl-7">
                      <span class="text-dark-75">Numbering</span>
                    </th>
                    <th style="min-width: 100px">Title</th>
                    <th style="min-width: 100px">Stasiun</th>
                    <th style="min-width: 100px">Tipe</th>
                    <th style="min-width: 101px">Scope</th>
                    <th style="min-width: 101px">Logistic</th>
                    <th style="min-width: 101px">SHD External</th>
                    <th style="min-width: 101px">Change Management</th>
                  </tr>
                </thead>

                <tbody>
                  <template
                    v-for="(item, i) in this.$store.getters.getterEditChecklist"
                  >
                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': emptyTableEdit
                      }"
                    >
                      <td class="text-center" colspan="9">Data kosong</td>
                    </tr>

                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': tableLoaderEdit
                      }"
                    >
                      <td colspan="9" class="text-center">
                        <div class="text-center">
                          <b-spinner
                            variant="primary"
                            label="Spinning"
                          ></b-spinner>
                        </div>
                      </td>
                    </tr>

                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': mainTableEdit
                      }"
                    >
                      <td class="pl-0 ">
                        <span
                          class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                        >
                          {{ item.no }}
                        </span>
                      </td>

                      <td>
                        <span
                          class="text-dark-75 font-weight-bolder d-block font-size-lg"
                        >
                          {{ item.numbering }}
                        </span>
                      </td>

                      <td>
                        <span
                          class="text-dark-75 font-weight-bolder d-block font-size-lg"
                        >
                          {{ item.title }}
                        </span>
                      </td>

                      <td>
                        <span class="text-muted font-weight-bold d-block">
                          {{ item.station }}
                        </span>
                      </td>

                      <td>
                        <span class="text-muted font-weight-bold d-block">
                          {{ item.type }}
                        </span>
                      </td>

                      <td>
                        <span class="text-muted font-weight-bold d-block">
                          {{ item.scope }}
                        </span>
                      </td>

                      <td>
                        <input type="checkbox" />
                      </td>
                      <td>
                        <input type="checkbox" />
                      </td>
                      <td>
                        <input type="checkbox" />
                      </td>
                    </tr>
                  </template>
                </tbody>
              </table>
            </div>
          </b-tab>
          <!-- end Drawing tab -->

          <!-- Form tab -->
          <b-tab title="Form">
            <div class="d-flex justify-content-end mb-3">
              <button class="btn btn-success mr-2">
                Simpan
              </button>
              <button
                class="btn btn-primary mr-2"
                @click.prevent="loadEditChecklist('DOC')"
              >
                Load Design
              </button>
              <button
                class="btn btn-secondary"
                style="border-top-right-radius: 0; border-bottom-right-radius: 0;"
              >
                <i class="flaticon2-search-1"></i>
              </button>
              <input
                type="text"
                style="border-top-left-radius: 0; border-bottom-left-radius: 0; border: 1px solid #e6e6e6;"
              />
            </div>

            <div class="table-responsive">
              <table
                class="table table-head-custom table-vertical-center table-head-bg table-borderless"
              >
                <thead>
                  <tr class="text-left">
                    <th style="min-width: 100px">No</th>
                    <th style="min-width: 250px" class="pl-7">
                      <span class="text-dark-75">Numbering</span>
                    </th>
                    <th style="min-width: 100px">Title</th>
                    <th style="min-width: 100px">Stasiun</th>
                    <th style="min-width: 100px">Tipe</th>
                    <th style="min-width: 101px">Scope</th>
                    <th style="min-width: 101px">Logistic</th>
                    <th style="min-width: 101px">SHD External</th>
                    <th style="min-width: 101px">Change Management</th>
                  </tr>
                </thead>

                <tbody>
                  <template
                    v-for="(item, i) in this.$store.getters.getterEditChecklist"
                  >
                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': emptyTableEdit
                      }"
                    >
                      <td class="text-center" colspan="9">Data kosong</td>
                    </tr>

                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': tableLoaderEdit
                      }"
                    >
                      <td colspan="9" class="text-center">
                        <div class="text-center">
                          <b-spinner
                            variant="primary"
                            label="Spinning"
                          ></b-spinner>
                        </div>
                      </td>
                    </tr>

                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': mainTableEdit
                      }"
                    >
                      <td class="pl-0 ">
                        <span
                          class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                        >
                          {{ item.no }}
                        </span>
                      </td>

                      <td>
                        <span
                          class="text-dark-75 font-weight-bolder d-block font-size-lg"
                        >
                          {{ item.numbering }}
                        </span>
                      </td>

                      <td>
                        <span
                          class="text-dark-75 font-weight-bolder d-block font-size-lg"
                        >
                          {{ item.title }}
                        </span>
                      </td>

                      <td>
                        <span class="text-muted font-weight-bold d-block">
                          {{ item.station }}
                        </span>
                      </td>

                      <td>
                        <span class="text-muted font-weight-bold d-block">
                          {{ item.type }}
                        </span>
                      </td>

                      <td>
                        <span class="text-muted font-weight-bold d-block">
                          {{ item.scope }}
                        </span>
                      </td>

                      <td>
                        <input type="checkbox" />
                      </td>
                      <td>
                        <input type="checkbox" />
                      </td>
                      <td>
                        <input type="checkbox" />
                      </td>
                    </tr>
                  </template>
                </tbody>
              </table>
            </div>
          </b-tab>
          <!-- end Form tab -->
        </b-tabs>

        <!-- pagination -->
        <div
          v-bind:class="{
            'd-none': paginationChecklist
          }"
        >
          <div class="d-flex justify-content-end">
            <button
              class="btn btn-primary"
              v-if="this.$store.getters.getterStartEditChecklist == 0"
              disabled
            >
              {{ prevChecklist }}
            </button>
            <button
              class="btn btn-primary"
              v-else
              @click.prevent="prevPageChecklist"
            >
              {{ prevChecklist }}
            </button>

            <button
              class="btn btn-primary"
              v-if="
                this.$store.getters.getterActiveEditChecklist ===
                  this.$store.getters.getterTotalEditChecklist
              "
              disabled
            >
              {{ nextChecklist }}
            </button>
            <button
              class="btn btn-primary"
              v-else
              @click.prevent="nextPageChecklist"
            >
              <div
                class="text-center"
                v-bind:class="{
                  'd-none': loaderNextChecklist
                }"
              >
                <b-spinner
                  variant="secondary"
                  label="Spinning"
                  style="width: 1rem; height: 1rem;"
                ></b-spinner>
              </div>
              {{ nextChecklist }}
            </button>
          </div>
        </div>
        <!-- end pagination -->
      </div>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { EDIT_CHECKLIST_DISTRIBUTION } from "@/core/services/store/distribution.module";

export default {
  name: "check-list",
  data() {
    return {
      filter: {
        status: null,
        name: null,
        code: null,
        owner: null,
        contractNumber: null
      },
      prevChecklist: "prev",
      nextChecklist: "Next",
      paginationChecklist: true,
      loaderNextChecklist: true,
      emptyTableEdit: false,
      tableLoaderEdit: true,
      mainTableEdit: true,
      tabsEdit: 1
    };
  },
  methods: {
    async nextPageChecklist() {
      var start = 1;
      var end = 2;
      var active = 2;
      await this.$store.dispatch(EDIT_CHECKLIST_DISTRIBUTION, {
        start: start,
        end: end,
        activePage: active,
        type: "DOC"
      });
    },

    async prevPageChecklist() {
      var start = 0;
      var end = 1;
      var active = 1;
      await this.$store.dispatch(EDIT_CHECKLIST_DISTRIBUTION, {
        start: start,
        end: end,
        activePage: active,
        type: "DOC"
      });
    },

    async loadEditChecklist(type) {
      this.loaderNextChecklist = false;
      this.nextChecklist = "";
      this.emptyTableEdit = true;
      this.tableLoaderEdit = false;
      this.mainTableEdit = true;

      await this.$store.dispatch(EDIT_CHECKLIST_DISTRIBUTION, {
        start: 0,
        end: 1,
        activePage: 1,
        type: type
      });

      this.emptyTableEdit = true;
      this.tableLoaderEdit = true;
      this.mainTableEdit = false;
      this.loaderNextChecklist = true;
      this.nextChecklist = "Next";

      if (this.$store.getters.getterTotalEditChecklist >= 2) {
        this.paginationChecklist = false;
      }
    }
  },
  async mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Checklist Distribution" }]);
  },
  computed: {
    currentTab() {
      return this.tabsEdit;
    }
  },
  watch: {
    currentTab(value) {
      if (value == 1) {
        this.mainTableEdit = true;
        this.emptyTableEdit = false;
        this.paginationChecklist = true;
      } else {
        this.mainTableEdit = true;
        this.emptyTableEdit = false;
        this.paginationChecklist = true;
      }
    }
  }
};
</script>

<style></style>
